function [odds, matrix] = constructOdds2(clicks,triscan,data,subBlock,offset)
subBlock = markGames(subBlock);
nscans = size(data,1);
labels=scanLabels(clicks,triscan,nscans);
data=makeTraining1(data,labels,offset,subBlock);
data=data(data(:,5)~=11,:);
nclass = size(data,1);
ngames = max(data(:,3));
ncat = max(data(:,5));
probs = ones(nclass,ncat);
matrix = zeros(ncat,ncat);
data(:,5)=data(:,5)-1;
for i = 1:ngames
    x = find(data(:,3) == i);
    if not(isempty(x))
        y = find((data(:,3) ~= i).*(data(:,1) == data(x(1),1))==1);
        z = find((data(:,3) ~= i).*(data(:,1) ~= data(x(1),1))==1);
        [p, m] = lineardisc2(cat(1,repmat(data(y,5:end),15,1),data(z,5:end)),data(x,5:end));
         probs(x,:) = p;
    end
end
odds = ones(nscans,ncat);
for i = 1:nclass
    odds(data(i,4),:)=probs(i,:);
end
for i = 1:nclass;
    j = find(probs(i,:)==max(probs(i,:)),1);
    matrix(data(i,5)+1,j)=matrix(data(i,5)+1,j)+1;
end