function priors  = legalSims1(matrices,whole,p,states,triples)
% creates a  combination of p weighting of the record on a million games
% played by the imperfect memory model and (1-p) of the legal moves
matrices = .75*whole+.25*matrices;
priors = zeros(625,3,24);
legals = legal1(states,triples);
for i = 1:625
    legals(i,:)= reshape(legals(i,:)/sum(legals(i,:)),1,1,24);
    temp = reshape(legals(i,:),1,1,24);
    for j = 1:3
        tot = sum(matrices(i,j,:));
        if tot > 0
            matrices(i,j,:) =matrices(i,j,:)/tot;
            priors(i,j,:) = p*matrices(i,j,:)+(1-p)*temp;
        else
            matrices(i,j,:)= 0;
            priors(i,j,:)=temp;
        end
    end
end
    
