function [probs,matrix, vals1, vals2, weights, constants] = lineardisc2(train,test)
ncat = max(train(:,1))+1;
nscans = size(train,1);
Sorted = sortrows(train,1);
nvars = size(train,2)-1;
Cov = zeros(nvars,nvars);
means = repmat(-1000,ncat,nvars);
weights = zeros(ncat,nvars);
constants = zeros(ncat,1);
ntrain = size(train,1);
ntest = size(test,1);
vals1 = zeros(ntrain,ncat);
vals2 = zeros(ntest,ncat);
matrix = zeros(ncat,ncat);
probs = zeros(ntest,ncat);
start =1;
for i = 1:ncat
    if i<ncat
        stop = find(Sorted(:,1)>=i,1)-1;
    else
        stop = nscans;
    end
    if stop >= start
        means(i,:) = mean(Sorted(start:stop,2:end));
        Cov = Cov + cov(Sorted(start:stop,2:end))*(stop-start);
    end
    start = stop+1;
end
Cov = Cov/(nscans-ncat);
for i = 1:ncat
    if means(i,1)~=0
        weights(i,:) = means(i,:)/Cov;
        constants(i) = .5*means(i,:)*weights(i,:)';
        vals1(:,i) =  train(:,2:end) * weights(i,:)' - constants(i);
        vals2(:,i) =  test(:,2:end) * weights(i,:)' - constants(i);
    end
end
for i = 1:ntest;
    j = find(vals2(i,:)==max(vals2(i,:)),1);
    matrix(test(i,1)+1,j)=matrix(test(i,1)+1,j)+1;
    x = exp(vals2(i,:));
    probs(i,:)=x/sum(x);
end
    
               

