function [tprobs, aprobs] = tripleData5(game,triples,subj,others)
conditionals = empiricalProbs2(game(1:end-3,1),subj,others);
nturns = size(game,1)/3;
conditionals = reshape(conditionals,3,nturns-1,19);
tprobs=zeros(nturns,24);
aprobs=zeros(nturns,3);
for i = 1:nturns-1  
    for j = 1:24
        tprobs(i,j) = conditionals(1,i,triples(j,1))*conditionals(2,i,triples(j,2))*conditionals(3,i,triples(j,3));
    end
    aprobs(i,1)=sum(tprobs(i,1:16),2);
    aprobs(i,2)=sum(tprobs(i,17:20),2);
    aprobs(i,3)=sum(tprobs(i,21:24),2);
end
tprobs(nturns,17:24)=1;
aprobs(nturns,2:3)=1;