function [clickseq, seq, backs, backo, blogs] = ymemViterbi9(trans,clicks,triples,subj,others,states,opstates,cprob,visited,flag)
aops = opstates(:,1:3);
vops = opstates(:,4:6);
past1 = [1,2,5,6,9,10,13,14]';
past2 = past1+2';
past3 = [17:24]';
past = cat(2,past3,past1,past2);
temp = zeros(1,3);
%how operators change states is given by aops and vops
indices = zeros(9,9);
for i = 1:25
    indices(states(i,1)+1,states(i,2)+1) = i;
end  
if flag == 1
    cprobs = tripleData5(clicks,triples,subj,others).*cprob;
else
    cprobs = cprob;
end
nturns = size(cprobs,1)+1;
tlogs = log(trans);
clogs = log(cprobs);
%clogs gives the log likelihood of the data for each triple 
%tlogs gives the log likelihood of each triple in each state
backs = zeros(nturns,625,3);
backo = backs;
%backs gives the most likely operator that led to this state on this turn
blogs = log(zeros(nturns,625,3));
%blogs gives the log-likelihood of each state of each turn
seq = zeros(nturns,2);
blogs(1,1,1)=0;
for i = 2:nturns
    vi = find(visited(i,:)>0);
    for jj = 1:size(vi,2)  
        j = vi(jj);
            a = states(mod(j-1,25)+1,:);
            v = states(ceil(j/25),:);
            for m = 1:3
                 best = -inf;
                 op = 0;
                 bs = 0;
                for n = 1:8
                    k = past(n,m);
                    a1 = a - aops(k,2:3);
                    v1 = v - vops(k,2:3);
                    if min(a1) >= 0 && min(v1) >=0 && a1(1)>=a1(2) && v1(1)>=v1(2) && aops(k)<=a1(1)-a1(2) && vops(k)<=v1(1)-v1(2)
                        prior = indices(v1(1)+1,v1(2)+1)*25 +  indices(a1(1)+1,a1(2)+1) - 25;
                        temp(1) = blogs(i-1,prior,1)+clogs(i-1,k)+tlogs(prior,1,k);
                        temp(2) = blogs(i-1,prior,2)+clogs(i-1,k)+tlogs(prior,2,k);               
                        temp(3) = blogs(i-1,prior,3)+clogs(i-1,k)+tlogs(prior,3,k);
                        m1 = find(temp==max(temp),1);
                       % if i < 3 && mod(j-1,25)+1 < 5 && ceil(j/25) < 5 && max(temp) > -inf
                       %     cat(2,[i, prior, m1,j m,k], temp)
                       % end
                        if temp(m1) > best
                            best = temp(m1);
                            op = k;
                            bs = prior;
                        end
                    end
                end
                blogs(i,j,m)=best;
                backo(i,j,m) = op;
                backs(i,j,m) = bs;
            end           
    end
end
seq(end,1)=625;
for i = nturns-1:-1:1
    m = find(blogs(i+1,seq(i+1,1),:)==max(blogs(i+1,seq(i+1,1),:)),1);
    seq(i,1)=backs(i+1,seq(i+1,1),m);    
    seq(i,2)=backo(i+1,seq(i+1,1),m);
end
nclicks = size(clicks,1);
clickseq = zeros(nclicks,4);
clickseq(:,1)= clicks(:,4);
clickseq(:,3)= clicks(:,6);
for i = 1:3:nclicks
    clickseq(i:i+2,4) = triples(seq((i+2)/3,2),:)';
    clickseq(i:i+1,2) = ceil(clickseq(i:i+1,4)/4);    
    clickseq(i+2,2) = clickseq(i+2,4)-12;
end
clickseq(end,3)=18;
clickseq(end-2:end-1,3)=clickseq(end-2:end-1,1)*4;
clickseq(end-2,3)=clickseq(end-2,3)-1;

        
        
    
    

        
