function cprob = ycalccprob6(odds,triples,triscan,num,len)

% cprob-- the conditional probability of each triple in a game, which are
% calculated by the conditional probability
cprob=zeros(len,24);

for j=1:len
    condprob = ones(size(triples,1),1);
    for k = 1:3
        tempodds = odds(triscan{num+j}{k},:);
       
        condprob = condprob.*(tempodds(1,triples(:,k))').^(2/3);
        if size(tempodds,1)==2
           condprob = condprob.*(tempodds(end,triples(:,k))').^(2/3);
        elseif size(tempodds,1)>2
             condprob = condprob.*(tempodds(end,triples(:,k))').^(2/3);
            for i =2:size(tempodds,1)-1
                condprob = condprob.*tempodds(i,triples(:,k))';
            end
        end
    end
    condprob = condprob/sum(condprob);
    cprob(j,:)=condprob';
end