function [seq, matrix1, matrix2] = yclassifygames25 (Imclicks,triples,states,odds,triscan,opstates,subBlock,prior,flag,flag1)
visited=visitedStates1(mean(prior,4),legal(states,triples),opstates,states,0.000001);
%visited is used to limit the search for purposes of efficiency
odds=cat(2,repmat(odds(:,1),1,4),repmat(odds(:,2),1,4),repmat(odds(:,3),1,4),repmat(odds(:,4),1,4),odds(:,5:6));
%column 6 of clicks has the 11 category classification
clicks=transformClicks2(Imclicks,subBlock,triscan);
%change triples to have the 11 category classification
legaltrans = legalize(states,triples);
triples(:,1:2) = triples(:,1:2)*4-2*repmat((triples(:,3)==5),1,2);
triples(:,1)=triples(:,1)-1;
triples(:,3)=triples(:,3)+12;
nclicks = size(clicks,1);
seq = zeros(nclicks,5);
first = 1;
index = 1;
num=0;
while first < nclicks
    last = find(clicks(first:end,1)==0,1);
    last = last+first-1;
    len = (last-first+1);     
    cprob= ycalccprob6(odds,triples,triscan,num,len/3);
    tempclicks=clicks;
    tempclicks(first:last,:)=[];
    subj=tempclicks(tempclicks(:,7)==clicks(first,7),:);
    others=tempclicks(tempclicks(:,7)~=clicks(first,7),:);
     if flag1 == 1  
        trans = prior(:,:,:,clicks(first,7));
     else
        trans = legaltrans;
     end
    seq(index:index+len-1,1:4)=ymemViterbi9(trans,clicks(first:last,:),triples,subj,others,states,opstates,cprob,visited,flag);
    start = triscan{num+1}{1};
    seq(index:index+len-1,5) = subBlock(start(1));
    num=num+len/3;       
    index = index+len;
    first = last+1;
end
matrix1 = zeros(6,6);
matrix2 = zeros(18,18);
for i = 1:nclicks
    matrix1(seq(i,1),seq(i,2))=matrix1(seq(i,1),seq(i,2))+1;
    matrix2(seq(i,3),seq(i,4))=matrix2(seq(i,3),seq(i,4))+1;
end

    